#Python script to transform the CPAchecker CSV files into the format i need for further evaluation (OpenOffice Tables)

import csv,re

dictSimulators={}
dictProducts={}

for (filename, plname) in \
[('results_bonaire_20_02_java/elevator.zip.csv',"elevator"),\
('results_bonaire_20_02_java/email.zip.csv',"email"),\
('results_bonaire_20_02_java/mine.zip.csv',"mine")] :

	with open(filename, 'r') as f:
	    reader = csv.reader(f, delimiter='\t')
	    reader.next()#skip first row
	    headerrow=reader.next()
	    assert headerrow[0]=="spec"
	    assert headerrow[1]=="scalingFactor"
	    assert headerrow[2]=="product"
	    assert headerrow[3]=="defect"
	    assert headerrow[4]=="time"
	    assert headerrow[5]=="states"
	    assert headerrow[6]=="features"

	    

	    try:
		for row in reader:
			spec=row[0]
			product=row[2]
			if (row[3]=="false"):
				status="SAFE"
			else:
				status="DEFECT"
			cputime=row[4]
			states=row[5]
			features=row[6]
		


			if (product=="psBDD"):
				key = '{0}_{1:04d}'.format(plname, int(spec))
				dictSimulators.update({key : [plname, spec, product, states, cputime, status]})
			else:
				key = '{0}_{1:04d}_{2:04d}'.format(plname, int(spec), int(product))
				dictProducts.update({key : [plname, spec, product, features, states, cputime, status]})

	    except csv.Error, e:
		sys.exit('file %s, line %d: %s' % (filename, reader.line_num, e))        
if (len(dictSimulators)>0):
	writer = csv.writer(open('Simulators.csv', 'w'), delimiter='\t')
	for key in sorted(dictSimulators.iterkeys()):
	    value = dictSimulators[key]
	    print "%s: %s" % (key, value)
	    writer.writerow([value[0],value[1],value[2],"NA", "NA", value[3], value[4], "NA", 1, value[5]])

if (len(dictProducts)>0):
	writer = csv.writer(open('Products.csv', 'w'), delimiter='\t')
	for key in sorted(dictProducts.iterkeys()):
	    value = dictProducts[key]
	    print "%s: %s" % (key, value)
	    productshort = "%s:%s" % (value[2],value[3])
	    writer.writerow([value[0],value[1],productshort,"NA", "NA", value[4], value[5], "NA", 0, value[6]])

print "format is: plname\tspec\tproduct\tNA\tNA\tstates\tcputime\tNA\tstatus"


